/*************************************************************************
 * This file is part of Crosroads 1.38, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "crossroads.h"

int backend_available (int target) {
    /* Backend is available when:
     * (a) The state indicates availability;
     * (b) Either, there is no max to the active connections, or
     *     the # of connections is below the max.
     */
    if (servicereport->backendstate[target].avail == st_available &&
	(activeservice->backend[target].maxconnections == 0 ||
	 activeservice->backend[target].maxconnections >
	 servicereport->backendstate[target].nclients)) {
	msg ("Service %s: target nr %d is available", 
	     activeservice->name, target);
	return (1);
    }

    msg ("Service %s: target nr %d is unavailable", 
	 activeservice->name, target);
    return (0);
}
