/*************************************************************************
 * This file is part of Crosroads 1.38, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "crossroads.h"

void create_commandline_space () {
    char **argv;
    int i;
    
    /* Here's a dirty hack for Linux systems. We're going to get
     * daemonized (unless -f was given) and we'll want to change the
     * program name as it appears in the ps list.
     * So we re-exec ourselves with a dummy -i flag that creates
     * space on the commanedline.
     */
#   if SET_PROC_TITLE_BY_ARGV == 1
    if (! iflag_present) {
	argv = xmalloc ( (org_argc + 2) * sizeof(char*));
	
	argv[0] = org_argv[0];
	argv[1] = "-ixxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
	          "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx";
	argv[org_argc + 1] = 0;

	for (i = 1; i < org_argc; i++)
	    argv[i + 1] = org_argv[i];
	argv[org_argc + 1] = 0;

	execv (argv[0], argv);
	execvp (argv[0], argv);
	error ("Failed to re-exec program: %s",
	       strerror(errno));
    }
#   endif
}
