/*************************************************************************
 * This file is part of Crosroads 1.38, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/
#include "crossroads.h"

int init_sockaddr (struct sockaddr_in *name,
                    const char *hostname, int port) {
    struct hostent *hostinfo;

    if (program_stage != stage_retrying)
	msg ("Service %s: trying to connect to backend %s:%d",
	     activeservice->name, hostname, port);
    name->sin_family = AF_INET;
    name->sin_port = htons (port);
    if (! (hostinfo = gethostbyname (hostname)) )
	return (1);
    name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
    return (0);
}
