/*************************************************************************
 * This file is part of Crosroads 1.38, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "crossroads.h"

#define SHOWDEF(a,b,c) 							\
    printf ("%-22s %-31s %s \n", b, c, a ? "yes" : "no");		

void show_config () {
    printf ("VER                    version:                        %s\n"
            "REVVER                 revision version (REVVER):      %s\n"
            "DEFAULT_CONF           default configuration file:     %s\n"
            "MAX_BACKEND            max nr. of backends in service: %d\n"
            "SHM_MASK               magic shared memory number:     0x%x\n"
            "SLEEP_TIME             service inactivy pause          %d\n"
            "CONNECT_TIMEOUT        backend connect timeout         %d\n"
            "RETRY_WAIT             backend retry pause             %d\n"
            "TCP_BUFSZ              network buffer size             %d\n"
            "BINDIR                 installation directory          %s\n"
            "SET_PROC_TITLE_BY_ARGV argv assumed linear array       %d\n"
            "EXTRALIBS              extra library dependencies      %s\n"
            "LIBS                   standard library dependencies   %s\n"
	    ,
	    VER, REVVER, DEFAULT_CONF, MAX_BACKEND, SHM_MASK, SLEEP_TIME,
	    CONNECT_TIMEOUT, RETRY_WAIT, TCP_BUFSZ, BINDIR,
	    SET_PROC_TITLE_BY_ARGV, EXTRALIBS, LIBS);
    SHOWDEF (HAVE_MALLOC_H,   "HAVE_MALLOC_H",   "<malloc.h> present");
    SHOWDEF (HAVE_STDINT_H,   "HAVE_STDINT_H",   "<stdint.h> present");
    SHOWDEF (HAVE_FLOCK,      "HAVE_FLOCK",      "flock() present");
    SHOWDEF (HAVE_LOCKF,      "HAVE_LOCKF",      "lockf() present");
    SHOWDEF (HAVE_STRLCAT,    "HAVE_STRLCAT",    "strlcat() present");
    SHOWDEF (HAVE_SRANDDEV,   "HAVE_SRANDDEV",   "sranddev() present");
    SHOWDEF (HAVE_VSYSLOG,    "HAVE_VSYSLOG",    "vsyslog() present");
    SHOWDEF (HAVE_STRCASESTR, "HAVE_STRCASESTR", "strcasestr() present");
}
