/*************************************************************************
 * This file is part of Crosroads 1.38, a load balancer and fail over
 * utility for TCP. Copyright (c) Karel Kubat, distributed under GPL.
 * Visit http://crossroads.e-tunity.com for information.
 *************************************************************************/

#include "crossroads.h"

int tell_service (int ac, char **av) {
    Service *target_service = 0;
    int target_backend = -1, i;
    Backendavail avail;
    

    for (i = 0; i < nservice; i++)
	if (!strcasecmp (service[i].name, av[0])) {
	    target_service = service + i;
	    break;
	}
    if (!target_service)
	error ("Service '%s' isn't known. "
	       "Maybe the configuration has changed?", av[0]);

    for (i = 0; i < target_service->nbackend; i++)
	if (!strcasecmp (target_service->backend[i].name, av[1])) {
	    target_backend = i;
	    break;
	}
    if (target_backend == -1)
	error ("Backend '%s' of service '%s' isn't known. "
	       "Maybe the configuration has changed?", av[1], av[0]);

    if ( (avail = string_to_state (av[2])) == st_unknown )
	error ("Incorrect state '%s'.", av[2]);

    alloc_reporter (target_service, 0);
    servicereport->backendstate[target_backend].avail = avail;
    servicereport->backendstate[target_backend].fail  = 0;
    msg ("Marked backend %s of service %s as %s.",
	 av[1], av[0], av[2]);
    return (1);
}
	       
